#include <iostream>
#include <cpprest/http_client.h>
#include <cpprest/filestream.h>
#include <cpprest/json.h>
#include <cpprest/uri.h> 

using namespace std;
using namespace web::http::client;
using namespace web::http;
using namespace web::json;

/*
	REQUEST BODY
	{
		"op": "pattern",
		"user": "USERNAME"
		"pass": "PASSWORD",
		"patternCode": "PATTERNCODE",
		"toNum": "98912xxxxxxxx",
		"fromNum": "+9810001",
		"inputData": [
			{
				"Name": "Ali",
				"Code": "782220"
			}
		]
	}
*/

int main(){
    uri base_uri(U("http://188.0.240.110/api/select"));
	http_client client(base_uri);
	web::http::http_request postTestRequest;

	// postTestRequest.set_request_uri(U("api/select"));
	// postTestRequest.set_method(web::http::methods::POST);

	// create post parameters for the body (as json). 
	web::json::value postParameters = web::json::value::object();
	web::json::value patternvalue = web::json::value::object();
	web::json::value patternvalues = web::json::value::array();

	// initialize request params
	postParameters["op"] = web::json::value::string("pattern");
	postParameters["user"] = value::string(U("USER-NAME"));
	postParameters["pass"] = value::string(U("PASSWORD"));
	postParameters["fromNum"] = value::string(U("+9810001"));
	postParameters["toNum"] = value::string(U("98912xxxxxx"));
	postParameters["patternCode"] = value::string(U("XXXXX")); // your unique pattern code

	// define you pattern parameters
	patternvalue["Name"] = value::string(U("Ippanel"));
	patternvalue["Code"] = value::string(U("906041"));

	patternvalues[0] = patternvalue;

	postParameters["inputData"] = patternvalues;

	postTestRequest.set_body(postParameters);

	cout << postParameters.to_string().c_str();

	http_response response = client.request(methods::POST,"", postParameters.to_string().c_str(), "application/json").get();

    cout << response.body();
}